import { ApolloCache, Cache, DataProxy, Transaction } from 'apollo-cache';
import { DocumentNode } from 'graphql';
import { SerialisedState } from './cache-interfaces';
export interface ApolloCacheLiteOptions {
    getIdFromObject?(obj: any): string | null;
}
export declare class ApolloCacheLite extends ApolloCache<SerialisedState> {
    private store;
    private queries;
    private watchers;
    private options;
    constructor(options?: ApolloCacheLiteOptions);
    diff(query: DataProxy.Query<any>): DataProxy.DiffResult<any>;
    watch(watcher: Cache.WatchOptions): () => void;
    write(options: Cache.WriteOptions): void;
    read<T>(query: Cache.ReadOptions): T;
    readFragment<T>(options: DataProxy.Fragment<any>): T;
    extract(): SerialisedState;
    restore(serialisedState: SerialisedState): ApolloCacheLite;
    reset(): Promise<void>;
    transformDocument(document: DocumentNode): DocumentNode;
    evict<TVariables = any>(query: Cache.EvictOptions<TVariables>): Cache.EvictionResult;
    removeOptimistic(id: string): void;
    performTransaction(transaction: Transaction<SerialisedState>): void;
    recordOptimisticTransaction(transaction: Transaction<SerialisedState>, id: string): void;
}
