"use strict";
exports.__esModule = true;
var deepmerge = require("deepmerge");
function getHash(s) {
    var str = JSON.stringify(s);
    var hash = 0;
    if (typeof str === 'undefined' || !str.length) {
        return String(hash);
    }
    for (var i = 0; i < str.length; i++) {
        var char = str.charCodeAt(i);
        hash = ((hash << 5) - hash) + char;
        hash = hash & hash;
    }
    return String(hash);
}
exports.getHash = getHash;
function getHashForQuery(query) {
    return getHash(query.query.loc.source.body || '') + '___' + getHash(query.variables || {});
}
exports.getHashForQuery = getHashForQuery;
function getCacheableNodes(obj, getIdFromNode) {
    var nodes = {};
    for (var _i = 0, _a = Object.keys(obj); _i < _a.length; _i++) {
        var key = _a[_i];
        var value = obj[key];
        if (key === '__typename') {
            var id = getIdFromNode(obj);
            if (id) {
                nodes[value] = nodes[value] || {};
                nodes[value][id] = obj;
            }
        }
        if (value === Object(value)) {
            nodes = deepmerge(nodes, getCacheableNodes(value, getIdFromNode));
        }
    }
    return nodes;
}
exports.getCacheableNodes = getCacheableNodes;
function getDefaultIdFromNode(node) {
    if (typeof node.id === 'undefined' && typeof node._id === 'undefined') {
        return;
    }
    return node.id || node._id;
}
exports.getDefaultIdFromNode = getDefaultIdFromNode;
